require(Morpho);require(Rvcg);require(rgl);require(ffmanova)
material3d(specular=1)
load("Rdata/atlas")
load("Rdata/skull.data")
SMvector=c(1:16)[-c(10:11)]
atlas.sl <- vcgPlyRead("Rdata/atlas.skull-onelayer.ply")
atlasnames <- names(atlas.c)
sml <- grep("P",atlasnames)
outlines <- unlist(atlas.c[grep("C",atlasnames)])
ccurves <- as.integer(outlines-2)
at <- createAtlas(atlas.m,landmarks = atlas[c(SMvector,outlines),],corrCurves = ccurves, patch = atlas[-c(sml,outlines),])
#### outliers found late ####
455,101
#### sort specimen according to length of asymmetric displacement ####
asym.bonelist <- NULL; for (i in 1:length(asym.1)){asym.bonelist[i]<-which(asym.1==sort(asym.1,decreasing=T)[i])}
skull.data <- skull.slide$dataslide
skull.data <- skull.data[,,-c(455,101)]
factors <- data.frame(pop=name2factor(skull.data,which=6))
factors$sex <- name2factor(skull.data,which=7)
factors$age <- name2num(skull.data,which=5:4)
factors$age[factors$age > 200] <- 26 ## fix wrong date
factors$raw <- dimnames(skull.data)[[3]]
factors$pop.sex <- name2factor(skull.data,which=6:7)
adu <- which(factors$age >= 18)
factors.adu <- factors[adu,]
skull.data.adu <- skull.data[,,adu]


## Formulate Hypotheses
procNoSym <- procSym(skull.data.adu)

maha <- mahalanobis(procNoSym$PCscores[,1:30],cov=cov(procNoSym$PCscores[,1:30]),center=0)
bad <- which(maha > 80)## exclude individuals too far to be acceptable
factors.adu <- factors.adu[-bad,]
skull.data.adu <- skull.data.adu[,,-bad]
proc <- procSym(skull.data.adu,pairedLM = symbone)
procNoSym <- procSym(skull.data.adu)

## cutoff 95 % = 23
barplot(procNoSym$Variance[1:23,2] )
gPCA <- groupPCA(procNoSym$PCscores[,1:23],groups = factors.adu$sex)
pdf("groupPCAnosymBW.pdf",width = 12,height = 12,family="Arial")
spm(gPCA$Scores,groups=factors.adu$pop.sex,smooth=F, by.groups=T,pch=0:3,,cex=2,ellipse=T,reg.line=F,col=c("grey0","grey50","grey0","grey50"))
dev.off()


cairo_pdf("ellCairo.pdf")
spm(gPCA$Scores,groups=factors.adu$pop.sex,smooth=F, by.groups=T,pch=c("\u2640","\u2642","\u2640","\u2642"),cex=1.3,ellipse=T,reg.line=F,col=c("grey0","grey50","grey0","grey50"))
dev.off()

## cutoff 95% Sym=13 Asym=21
qqmat(lm(proc$PCscore_sym[,1:13]~factors.adu$pop)$residuals,square = F)
qqmat(lm(proc$PCscore2asym[,1:21]~factors.adu$pop)$residuals,square = F)
### SYMMETRY
## linear model generation and testing
require(ffmanova);require(car);require(MASS)
lm.pop <- lm(proc$PCscore_sym[,1:13] ~ factors.adu$pop)
lm.pop.sex <- lm(proc$PCscore_sym[,1:13] ~ factors.adu$pop*factors.adu$sex)
modell <- ~(factor(c("ch","eu")))
predPop <- predictShape.lm(lm.pop,modell,PC=proc$PCsym[,1:13],proc$symmean)
predPopMesh <- as.list(1:2)
predPopMesh <- lapply(predPopMesh,function(x) x <- warp.mesh(atlas.sl,skull.data[,,554],predPop$predicted[,,x]))
shade3d(predPopMesh[[1]],col="grey10",alpha=0.7,specular=1)
shade3d(predPopMesh[[2]],col="grey90",alpha=0.7,specular=1)
deformGrid3d(predPop$predicted[,,1],predPop$predicted[,,2],col1="grey10",col2="grey90",ngrid=0,add=T)

ffmanova(lm.pop,stand=F)
ffmanova(lm.pop.sex,stand = F)
ldpop <- lda(proc$PCscore_sym[,1:13],grouping = factors.adu$pop,CV=T)
permu.pop.sex <- permuvec(proc$PCscore_sym[,1:13],groups = factors.adu$pop,subgroups = factors.adu$sex,scale = F)## angle = 34.03°
## show Pop.specific sexdimorph
modell <- ~(factor(c("ch","ch","eu","eu"))*factor(c("ma","fe","ma","fe")))
predPopSex <- predictShape.lm(lm.pop.sex,modell,PC=proc$PCsym[,1:13],proc$symmean)

spm(cbind(proc$PCscore_sym[,1:5],proc$size),groups=factors.adu$pop.sex,by.groups=T)
#ggMatvsVar(proc$PCscore_sym[,1:5],proc$size,group = factors.adu$pop)

### SYMMETRY
## linear model generation and testing of directional asymmetry
## shape minus DA

##first variant common asymmetry
euAsymMean <- apply(proc$Asym[,,factors.adu$pop=="eu"],1:2,mean)
chAsymMean <- apply(proc$Asym[,,factors.adu$pop=="ch"],1:2,mean)
popmeans <- tapply(1:length(factors.adu$pop),factors.adu$pop,function(x) x <- apply(proc$Asym[,,x],1:2,mean))
shapeMinusDA <- proc$rotated
shapeMinusDA[,,factors.adu$pop=="eu"] <- sweep(shapeMinusDA[,,factors.adu$pop=="eu"],1:2,euAsymMean)
shapeMinusDA[,,factors.adu$pop=="ch"] <- sweep(shapeMinusDA[,,factors.adu$pop=="ch"],1:2,chAsymMean)
shapeAsymNoDA <- shapeMinusDA-proc$Sym
asymDevMat <- vecx(shapeAsymNoDA)
asymDevPrc <- prcomp(asymDevMat,center = F)
#asymDevMat <- vecx(proc$Asym)
asymDevMaha <- mahalanobis(asymDevPrc$x[,1:21],center = 0,cov=cov(asymDevPrc$x[,1:21]))
asymDev <- apply(asymDevMat,1,function(x) x <- sqrt(sum(x^2)))
lmfluctPop <- lm(log(asymDev) ~ factors.adu$pop)
lmfluctMahaPop <- lm(log(asymDevMaha) ~ factors.adu$pop)
anova(lmfluctPop)
anova(lmfluctMahaPop)
lmfluctPopSex <- lm(log(asymDev) ~ factors.adu$pop*factors.adu$sex)
lmfluctMahaPopSex <- lm(log(asymDevMaha) ~ factors.adu$pop*factors.adu$sex)
anova(lmfluctPopSex)
anova(lmfluctMahaPopSex)


## second variant common asymmetry
shapeMinusDA2 <- sweep(proc$rotated,1:2,apply(proc$Asym,1:2,mean))
shapeAsymNoDA2 <- shapeMinusDA2-proc$Sym
asymDevMat2 <- vecx(shapeAsymNoDA2)
asymDevPrc2 <- prcomp(asymDevMat2,center = F)
#asymDevMat <- vecx(proc$Asym)
asymDevMaha2 <- mahalanobis(asymDevPrc2$x[,1:21],center = 0,cov=cov(asymDevPrc2$x[,1:21]))
asymDev2 <- apply(asymDevMat2,1,function(x) x <- sqrt(sum(x^2)))

dirAsymPop <- asymPerm(proc,factors.adu$pop,10000)
lm.pop.asym <- lm(proc$PCscore_asym[,1:21] ~ factors.adu$pop)
permuAsym <- permudist(proc$PCscore_asym[,1:21],groups = factors.adu$pop,rounds = 10000)
predPopAsym<- predictShape.lm(lm.pop.asym,~factor(c("eu","ch")),PC=proc$PCasym[,1:21],proc$mshape)


lm.pop.sexAsym <- lm(proc$PCscore_asym[,1:21] ~ factors.adu$pop*factors.adu$sex)
chmean <- proc$symmean+10*apply(proc$Asym[,,factors.adu$pop=="ch"],1:2,mean)
eumean <- proc$symmean+10*apply(proc$Asym[,,factors.adu$pop=="eu"],1:2,mean)
Asymmesh <- list(chmean,eumean)
Asymmesh <- lapply(Asymmesh,function(x) x <- warp.mesh(atlas.sl,skull.data[,,554],x))
### visualize landmarks
require(rgl);require(Rvcg)
atlas <- skull.slide$dataslide[,,556]
shade3d(atlas.m,col="white",specular=1)
texts <- vcgClost(atlas[SMvector,],atlas.m)
textpos <- t(texts$vb+texts$normals*5)[,1:3]
spheres3d(atlas[SMvector,])
text3d(textpos,text=paste0(1:length(SMvector)),cex=1.5,font=2)
plotNormals(texts,lwd=3,long=4)

curves <- unlist(atlas.c[grep("C",names(atlas.c))[-c(1:4)]])
patch <- unique(1:370)[-c(SMvector,curves)]
spheres3d(atlas[curves,],radius = 0.6,col="white")
spheres3d(atlas[patch,],radius = 0.4,col="black")

###qqplots

pdf("qqplot_sym.pdf",width = 8, height = 8,pointsize = )
qqmat(lm.pop$residuals)
dev.off()

postscript("qqplot_sym.ps",width = 8, height = 8,paper="special",horizontal =F, pointsize = 20)qqmat(lm.pop$residuals,square=F)
dev.off()

postscript("qqplot_asym.ps",width = 8, height = 8,paper="special",horizontal = F, pointsize = 20)
qqmat(lm(proc$PCscore_asym[,1:21]~factors.adu$pop)$residuals,square = F)
dev.off()

postscript("qqplot_nosym.ps",width = 8, height = 8,paper="special",horizontal = F,pointsize = 20)
qqmat(lm(procNoSym$PCscores[,1:21]~factors.adu$pop)$residuals)
dev.off()

postscript("asymDevBoxMahaBW.ps",width = 8, height = 8,paper="special",horizontal = F,pointsize = 20)
#layout(matrix(1:2,1,2))
#boxplot(log(asymDev)~factors.adu$pop,notch = T,main="log-transformed Asymmetry")
boxplot(log(asymDevMaha)~factors.adu$pop.sex,notch = T,main="log-transformed Mahalanobisdistances^2")
dev.off()

postscript("asymDevBoxBW.ps",width = 8, height = 8,paper="special",horizontal = F,pointsize = 20)
#layout(matrix(1:2,1,2))
boxplot(log(asymDev)~factors.adu$pop.sex,notch = T,main="     log-transformed Asymmetry            ")
#boxplot(log(asymDevMaha)~factors.adu$pop,notch = T,,main="log-transformed Asymmetry")
#boxplot(log(asymDevMaha)~factors.adu$pop,notch = T,,main="log-transformed Mahalanobisdistances^2")
dev.off()
    
        
